#include "stdafx.h"

#include <cassert>

#include "Helpers.h"
#include <tchar.h>

HWND CreateMessageOnlyWindow()
{
  const HWND result = CreateWindowEx(
    0,
    _T("#32770"),
    _T("ddd"),
    0,
    CW_USEDEFAULT,
    CW_USEDEFAULT,
    200,
    200,
    HWND_DESKTOP,
    NULL,
    GetModuleHandle(NULL),
    NULL
   );
  if(!result) {
    assert(false);
  }
  ShowWindow( result, SW_SHOW);
  return result;
}

LONG_PTR MySetWindowLongPtr(HWND hWnd, int nIndex, LONG_PTR dwNewLong )
{
  SetLastError(0);
  LONG_PTR r = SetWindowLongPtr( hWnd, nIndex, dwNewLong );
  if ( r == 0 && GetLastError() != 0 ) {
    assert(false);
  }
  return r;
}

void SetWindowProc(HWND hwnd,WindowProcPtrType NewWndProc,WindowProcPtrType& PrevWndProc)
{
  PrevWndProc = (WindowProcPtrType)MySetWindowLongPtr(hwnd,GWLP_WNDPROC,(LONG_PTR)NewWndProc);
}

void InvokeMessagePump()
{
  BOOL bRet;
  MSG msg;
  //HWND hWnd;
  
  while( (bRet = GetMessage( &msg, NULL, 0, 0 )) != 0)
  { 
      if (bRet == -1)
      {
        // handle the error and possibly exit
        assert(false);
      }
      else
      {
          TranslateMessage(&msg); 
          DispatchMessage(&msg); 
      }
  }
}
